Bug 118964 - Sockets don't close properly with TeamWARE Office for Linux 6
Sockets don't close properly with TeamWARE Office for Linux 6
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: glibc (Show other bugs)
3.0
i686 Linux
high Severity high
: ---
: ---
Assigned To: Jakub Jelinek
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-03-23 04:42 EST by Mikko Levo
Modified: 2007-11-30 17:07 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-11-01 11:03:21 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
strace of process 5916 (tostart) (80.20 KB, text/plain)
2004-03-23 06:53 EST, Mikko Levo
no flags Details
strace of processes (38.44 KB, application/x-gzip)
2004-03-23 06:59 EST, Mikko Levo
no flags Details

  None (edit)
Description Mikko Levo 2004-03-23 04:42:27 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.4)
Gecko/20030624 Netscape/7.1 (ax)

Description of problem:
When TeamWARE Office for Linux 6 (E-mail and groupware software, see
http://www.teamware.com) is shutting down it can't close open sockets
properly. Similar problems occured with RHL9 but they could be solved
by updating the latest kernel and glibc RPMs (2003-11-13
RHSA-2003:325). I noticed that Enterprise Linux got glibc updates at a
same time but it contains different bug fixes. Previous Red Hat
Linuxes (7.3 and 8 tested) don't suffer from this problem.

Here is complete list of updates for RHL9 needed to solve above problem:

glibc-common-2.3.2-27.9.7.i386.rpm      
glibc-debug-2.3.2-27.9.7.i386.rpm       
glibc-profile-2.3.2-27.9.7.i386.rpm     
glibc-utils-2.3.2-27.9.7.i386.rpm       
glibc-2.3.2-27.9.7.i386.rpm
kernel-BOOT-2.4.20-30.9.i386.rpm
kernel-doc-2.4.20-30.9.i386.rpm
kernel-source-2.4.20-30.9.i386.rpm
kernel-2.4.20-30.9.i386.rpm
nscd-2.3.2-27.9.7.i386.rpm

Version-Release number of selected component (if applicable):
glibc-2.3.2-95.6

How reproducible:
Always

Steps to Reproduce:
1. Start TeamWARE Office for Linux 6
2. Open connection with client (etc. web)
3. Shutdown TeamWARE Office for Linux 6
4. Wait for 8-10 minutes until TeamWARE Office kills the connections
brutally

Actual Results:  See above. Also minor database corruption which can
be manually fixed. Not sure if there is possibility to have more
damage sometime.

Expected Results:  There should be clean shutdown without that extra
wait and error messages. 

Additional info:
Comment 1 Jakub Jelinek 2004-03-23 04:58:00 EST
There are no patches which could be related to this in RHL9 errata
with CVS dates beyond late Sep 2003 at which point RHEL3 glibc
has been forked from upstream CVS.  So it most probably most be something
else.
strace/ltrace dumps could help figuring out what's going on.
Is it using NPTL or LinuxThreads?
Comment 2 Mikko Levo 2004-03-23 06:53:02 EST
Created attachment 98776 [details]
strace of process 5916 (tostart)
Comment 3 Mikko Levo 2004-03-23 06:59:04 EST
Created attachment 98777 [details]
strace of processes

5916: tostart (starts and watches required child processes)
5923: toserver (main server process for TeamWARE Office)
5986: tostop (shutdowns all TeamWARE Office processes)
Comment 4 Mikko Levo 2004-03-23 07:01:33 EST
Above you can find straces of three processes that remain active
during hang/wait.

I don't know if this software uses NPTL or LinuxThreads. All I know is
that they are developing three different versions (Windows, Solaris
and Linux) if that might give you a clue.
Comment 5 Ulrich Drepper 2004-09-28 07:21:00 EDT
I don't know what you expect.  We cannot and will not debug 3rd party
binaries, especially not some proprietary code we have no sources of.

It is impossible that there is a problem with sockets which cause
delays which would not be generally present.  Much more likely there
is a lockup, either between threads or the processes.  We had a few
bugs in the early RHEL3 libpthread.  If after updating to the latest
glibc and kernel you still see problems, contact this ISV and ask them
to debug the binary.

I'll keep the bug open for a while.  If you have more details (or news
that it works), please post it.   If I don't hear anything I'll close
the bug soon.

Note You need to log in before you can comment on or make changes to this bug.